/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

/* flag status */
#define FLAG_SET    1u
#define FLAG_CLEAR  0u

#define i2c_buffersize   8
#define i2c_index        4

uint8 i2c_offset;           // Specifying the byte order of i2cBuffer
uint8 i2c_pointer;          // Specifying the current byte pointer of i2cBuffer
uint8 i2c_element;          // Specifying the element of two-dimensional array
uint8 i2cBuffer[i2c_buffersize+1];
volatile uint8 i2c_write_flag = FLAG_CLEAR;

uint8 ParamData[i2c_index][i2c_buffersize];
volatile uint8 temp;
volatile uint32 temp32;

int main()
{
    /* EZI2C start */
    EZI2C_Start();
    EZI2C_EzI2CSetBuffer1(sizeof(i2cBuffer)+1, sizeof(i2cBuffer)+1, (void *)i2cBuffer);
    
    CyGlobalIntEnable;                                          /* Enable global interrupts. */

    for(;;)
	{
        if(i2c_write_flag == FLAG_SET)
        {
// #define EZI2C_EZI2C_GET_INDEX(activeAddress)  ((uint32) (EZI2C_indexBuf1))
// #define EZI2C_EZI2C_GET_OFFSET(activeAddress) ((uint32) (EZI2C_offsetBuf1))
            i2c_offset = (uint32)EZI2C_offsetBuf1;
            i2c_pointer = (uint32)EZI2C_indexBuf1;
//          i2c_pointer = EZI2C_EZI2C_GET_INDEX(activeAddress);
//          i2c_offset = EZI2C_EZI2C_GET_OFFSET(activeAddress);
            if(i2c_offset == 0 && i2c_pointer == 1)
            {
                for(uint32 i=0; i<i2c_buffersize; i++)
                {
                    i2cBuffer[i+1] = ParamData[i2cBuffer[0]][i];
                }
            }
            else if(!(i2c_offset == i2c_pointer))
            {
                if(i2c_offset == 0)
                {
                    for(uint32 i=0; i<i2c_pointer-1; i++)
                    {
                        ParamData[i2cBuffer[0]][i] = i2cBuffer[i+1];
                    }
                }
                else
                {
                    for(uint32 i=0; i<i2c_pointer-i2c_offset; i++)
                    {
                        ParamData[i2cBuffer[0]][i+i2c_offset-1] = i2cBuffer[i+i2c_offset];
                    }
                }
                
                for(uint32 i=0; i<i2c_buffersize; i++)
                {
                    i2cBuffer[i+1] = ParamData[i2cBuffer[0]][i];
                }
            }
            
            i2c_write_flag = FLAG_CLEAR;
        }
    }
}

/*******************************************************************************
*  EZI2C_EZI2C_STRETCH_ISR_ENTRY_CALLBACK interrupt handler
*******************************************************************************/
void EZI2C_EZI2C_STRETCH_ISR_EntryCallback(void)
{
    if(0u != (EZI2C_GetSlaveInterruptSource() & EZI2C_INTR_SLAVE_I2C_WRITE_STOP))
    {
        i2c_write_flag = FLAG_SET;
        Pin_TEST_Write(~Pin_TEST_Read());
    }
}

/* [] END OF FILE */
